//+------------------------------------------------------------------+
//|                                                   sOpenBuyV3.mq4 
//+------------------------------------------------------------------+
#property copyright " valenok2003@mail.ru"
#property link      "http://bluedreamlab.ru"
#property show_inputs
#include <WinUser32.mqh>
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
extern string Rem_0 = "";
extern bool 
   TAKE_STOCH = true,
   NEXT_PERIOD_STOCH = true;   
extern string Rem_1 = "MACD";
extern bool 
   TAKE_MACD = true,
   NEXT_PERIOD_MACD = true;   
//------------------
extern int Magic = 777;
extern double Lot = 0.05;
extern bool 
   Alert_ON = false,
   Alert_ERR = true;
extern string 
   txt_Comment = "";
//------------------
string 
   Txt_Output = "";
//+-------
//+------------------------------------------------------------------+
int start(){
//------------------
//   
   if(TAKE_STOCH)
      if(check_stoch()!="UP")
         if(MessageBox("  , ?", " ", MB_YESNO) != IDYES) return(0);
   if(TAKE_MACD)
      if(check_MACD()!="UP")
         if(MessageBox("MACD  , ?", " MACD", MB_YESNO) != IDYES) return(0);
//------------------
   if(txt_Comment == "")txt_Comment = txt_TF(Period());
   int Slip = MathRound((MarketInfo(Symbol(),MODE_ASK)-MarketInfo(Symbol(),MODE_BID))/Point);
   int Cnt = 0;
   int _Ticket = -1;
   double _Price = NormalizeDouble(Ask,Digits);
   double _SL = 0;// if(Loss != 0)  _SL = NormalizeDouble(Bid - Loss*Point,Digits);
   double _TP = 0;// if(Profit != 0)_TP = NormalizeDouble(Bid + Profit*Point,Digits);
   while(_Ticket == -1 && Cnt < 100)  {
      _Ticket = OrderSend(Symbol(),OP_BUY,Lot,_Price,Slip,0,0,txt_Comment + " Mgc" + Magic,Magic,0,CLR_NONE);
      _Ticket = check_open_order(OP_BUY,_Ticket, GetLastError());
      Cnt++;
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//+               
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| check_stoch()    
//| :
//| - _Mode:
//| - 0 -      
//| - 1 -    
//| -  
//|  :
//| - "UP"  "NO"
//+------------------------------------------------------------------+
string check_stoch(int _Mode=0, double _Level = 20, int _K=5, int _D=3, int _S=3, int _Method=0, int _Price=0){  
   string _Function = "check_stoch():";
//------------------
   bool 
      _FLAG_CUR_PERIOD = false,
      _FLAG_NEXT_PERIOD = false;
   
   double _St_0M = iStochastic(NULL,0,_K,_D,_S,_Method,_Price,MODE_MAIN,0);
   double _St_0S = iStochastic(NULL,0,_K,_D,_S,_Method,_Price,MODE_SIGNAL,1);
   double _St_1M = iStochastic(NULL,0,_K,_D,_S,_Method,_Price,MODE_MAIN,1);
   double _St_0M_Plus = iStochastic(NULL,next_period(),_K,_D,_S,_Method,_Price,MODE_MAIN,0);
   double _St_0S_Plus = iStochastic(NULL,next_period(),_K,_D,_S,_Method,_Price,MODE_SIGNAL,1);
   double _St_1M_Plus = iStochastic(NULL,next_period(),_K,_D,_S,_Method,_Price,MODE_MAIN,1);
//------------------
   switch(_Mode){
      case 0:
         if(_St_0M >_St_1M && _St_0M > _Level)_FLAG_CUR_PERIOD = true;
      break;
      case 1:
         if(_St_0M >_St_0S  && _St_0M > _Level)_FLAG_CUR_PERIOD = true;
      break;
      default:break;
   }
   if(_FLAG_CUR_PERIOD) {
      switch(_Mode){
         case 0:
            if(_St_0M_Plus >_St_1M_Plus && _St_0M_Plus > _Level)_FLAG_NEXT_PERIOD = true;
         break;
         case 1:
            if(_St_0M_Plus >_St_0S_Plus  && _St_0M_Plus > _Level)_FLAG_NEXT_PERIOD = true;
         break;
         default:break;
      }
   }
   if(_FLAG_NEXT_PERIOD) return("UP");
   else return("NO");
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| check_MACD()   MACD 
//|  :
//| - "UP"  "NO"
//+------------------------------------------------------------------+
string check_MACD(int _fast_ema_period = 12, int _slow_ema_period = 26, int _signal_period = 9, int _applied_price = PRICE_CLOSE){  
   string _Function = "check_MACD():";
//------------------
   bool 
      _FLAG_CUR_PERIOD = false,
      _FLAG_NEXT_PERIOD = false;
   
   double _MACD_0M = iMACD(NULL,0,_fast_ema_period,_slow_ema_period,_signal_period,_applied_price,MODE_MAIN, 0); 
   double _MACD_0S = iMACD(NULL,0,_fast_ema_period,_slow_ema_period,_signal_period,_applied_price,MODE_SIGNAL, 0); 
   double _MACD_0M_Plus = iMACD(NULL,next_period(),_fast_ema_period,_slow_ema_period,_signal_period,_applied_price,MODE_MAIN, 0); 
   double _MACD_0S_Plus = iMACD(NULL,next_period(),_fast_ema_period,_slow_ema_period,_signal_period,_applied_price,MODE_SIGNAL, 0); 
 
//------------------
   if(_MACD_0M >_MACD_0S)_FLAG_CUR_PERIOD = true;
   if(_FLAG_CUR_PERIOD) if(_MACD_0M_Plus >_MACD_0S_Plus)_FLAG_NEXT_PERIOD = true;
   if(_FLAG_NEXT_PERIOD) return("UP");
   else return("NO");
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//+                
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| check_open_order()       
//| :
//| -  
//| -   
//| -  ,   OrderSend()                             
//|      -1
//+------------------------------------------------------------------+
int check_open_order(int _Type_Order, int _Ticket, int _ERROR)
{  string _Function = "check_open_order():";
//--------
   if(_Ticket > 0)
   {  OrderSelect(_Ticket,SELECT_BY_TICKET);
      if((OrderType() ==  OP_SELL || OrderType() ==  OP_BUY) && _ERROR == 0)
      {  output_alert(_Function+txt_order_type(_Type_Order)+" !");
      }
      else _Ticket = -1;
   }
   error(_Function + txt_order_type(_Type_Order), _ERROR);
//--------
   return(_Ticket);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| output_alert()  
//| :
//| -  
//+------------------------------------------------------------------+
void output_alert(string _Txt_Alert)
{  string _Function = "output_alert():";
   if(Alert_ON == true) Alert(txt_TF(Period()) + " " + txt_Comment + ": " + _Txt_Alert);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| txt_order_type()      
//+------------------------------------------------------------------+
string txt_order_type(int _Type_Order)
{  string _Function = "txt_order_type():",
      _Txt;
//--------
   switch(_Type_Order)
   {  case OP_BUY: _Txt = "OP_BUY";
      break;
      case OP_SELL: _Txt = "OP_SELL";
      break;
      case OP_BUYLIMIT: _Txt = "OP_BUYLIMIT";
      break;
      case OP_SELLLIMIT: _Txt = "OP_SELLLIMIT";
      break;
      case OP_BUYSTOP: _Txt = "OP_BUYSTOP";
      break;
      case OP_SELLSTOP: _Txt = "OP_SELLSTOP";
      break;
      default: 
         error(_Function, 4203);
      break;
   }  
   return(_Txt);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                14.06.2011
//+------------------------------------------------------------------+
//| txt_TF()                   
//+------------------------------------------------------------------+
string txt_TF( int _TF)
{  string _Function = "txt_TF():";
   string _Txt_TF;
   switch(_TF)
   {
     case PERIOD_M1:  _Txt_TF = "M1";  break;
     case PERIOD_M5:  _Txt_TF = "M5";  break;
     case PERIOD_M15: _Txt_TF = "M15"; break;
     case PERIOD_M30: _Txt_TF = "M30"; break;
     case PERIOD_H1:  _Txt_TF = "H1";  break;
     case PERIOD_H4:  _Txt_TF = "H4";  break;
     case PERIOD_D1:  _Txt_TF = "D1";  break;
     case PERIOD_W1:  _Txt_TF = "W1";  break;
     case PERIOD_MN1: _Txt_TF = "MN1"; break;
     default: Alert("   " + _TF); break;
   }
   return(_Txt_TF);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                14.06.2011
//+------------------------------------------------------------------+
//| next_period()       
//+------------------------------------------------------------------+
int next_period() {  
   string _Function = "next_period():";
//------------------
   switch(Period()) {
     case PERIOD_M1:  return(PERIOD_M5);
     case PERIOD_M5:  return(PERIOD_M15);
     case PERIOD_M15: return(PERIOD_M30);
     case PERIOD_M30: return(PERIOD_H1);
     case PERIOD_H1:  return(PERIOD_H4);
     case PERIOD_H4:  return(PERIOD_D1);
     case PERIOD_D1:  return(PERIOD_W1);
     case PERIOD_W1:  return(PERIOD_MN1);
     case PERIOD_MN1: return(PERIOD_MN1);
   }
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| error()  
//| :                  
//| -  ; 
//| -   
//| -  ;  
//+------------------------------------------------------------------+
string error(string _Function, int _Num_Error)
{  string _Txt_Error = "";
   switch(_Num_Error)
   { //----  ,   :
      case 0:   _Txt_Error = " ";                                               break;
      case 1:   _Txt_Error = " ,   ";                      break;
      case 2:   _Txt_Error = " ";                                             break;
      case 3:   _Txt_Error = " ";                                   break;
      case 4:   _Txt_Error = "  ";                                    break;
      case 5:   _Txt_Error = "   ";                      break;
      case 6:   _Txt_Error = "    ";                            break;
      case 7:   _Txt_Error = " ";                                        break;
      case 8:   _Txt_Error = "  ";                                   break;
      case 9:   _Txt_Error = "   ";             break;
      case 64:  _Txt_Error = " ";                                        break;
      case 65:  _Txt_Error = "  ";                                 break;
      case 128: _Txt_Error = "    ";                    break;
      case 129: _Txt_Error = " ";                                        break;
      case 130: _Txt_Error = " ";                                       break;
      case 131: _Txt_Error = " ";                                       break;
      case 132: _Txt_Error = " ";                                             break;
      case 133: _Txt_Error = " ";                                       break;  
      case 134: _Txt_Error = "    ";               break;
      case 135: _Txt_Error = " ";                                          break;
      case 136: _Txt_Error = " ";                                                 break;
      case 137: _Txt_Error = " ";                                             break;
      case 138: _Txt_Error = " ";                                               break;
      case 139: _Txt_Error = "    ";                  break;
      case 140: _Txt_Error = "  ";                                 break;
      case 141: _Txt_Error = "  ";                                   break;
      case 145: _Txt_Error = " ,     ";      break;
      case 146: _Txt_Error = "  ";                               break;
      case 147: _Txt_Error = "     ";   break;
      case 148: _Txt_Error = "   .";                     break;
      //----    MQL4-:
      case 4000: _Txt_Error = " ";                                              break;
      case 4001: _Txt_Error = "  ";                          break;
      case 4002: _Txt_Error = "  -  ";                          break;
      case 4003: _Txt_Error = "    ";                            break;
      case 4004: _Txt_Error = "    ";            break;
      case 4005: _Txt_Error = "      ";             break;
      case 4006: _Txt_Error = "    ";                     break;
      case 4007: _Txt_Error = "    ";                         break;
      case 4008: _Txt_Error = " ";                             break;
      case 4009: _Txt_Error = "   ";                   break;
      case 4010: _Txt_Error = "    ";                       break;
      case 4011: _Txt_Error = "  ";                                  break;
      case 4012: _Txt_Error = "    ";                              break;
      case 4013: _Txt_Error = "  ";                                         break;
      case 4014: _Txt_Error = " ";                                     break;
      case 4015: _Txt_Error = " ";                                    break;
      case 4016: _Txt_Error = " ";                             break;
      case 4017: _Txt_Error = " DLL  ";                                 break;
      case 4018: _Txt_Error = "  ";                         break;
      case 4019: _Txt_Error = "  ";                              break;
      case 4020: _Txt_Error = "     ";        break; 
      case 4021: _Txt_Error = "   ,   "; break;
      case 4022: _Txt_Error = " ";                                          break;
      case 4050: _Txt_Error = "   ";              break;
      case 4051: _Txt_Error = "   ";                 break;
      case 4052: _Txt_Error = "   ";                     break;
      case 4053: _Txt_Error = " ";                                          break;
      case 4054: _Txt_Error = "  -";            break;
      case 4055: _Txt_Error = "  ";                     break;
      case 4056: _Txt_Error = " ";                                    break;
      case 4057: _Txt_Error = "   ";                 break;
      case 4058: _Txt_Error = "   ";                     break;
      case 4059: _Txt_Error = "     ";                  break;
      case 4060: _Txt_Error = "  ";                                    break;
      case 4061: _Txt_Error = "  ";                                   break;
      case 4062: _Txt_Error = "   string";                          break;
      case 4063: _Txt_Error = "   integer";                         break;
      case 4064: _Txt_Error = "   double";                          break;
      case 4065: _Txt_Error = "    ";                   break;
      case 4066: _Txt_Error = "     ";  break;
      case 4067: _Txt_Error = "    ";                 break;
      case 4099: _Txt_Error = " ";                                             break;
      case 4100: _Txt_Error = "    ";                              break;
      case 4101: _Txt_Error = "  ";                                  break;
      case 4102: _Txt_Error = "   ";                           break;
      case 4103: _Txt_Error = "  ";                                 break;
      case 4104: _Txt_Error = "    ";                     break;
      case 4105: _Txt_Error = "    ";                                 break;
      case 4106: _Txt_Error = " ";                                      break;
      case 4107: _Txt_Error = "     ";         break;
      case 4108: _Txt_Error = "  ";                                   break;
      case 4109: _Txt_Error = "  .   .";     break;
      case 4110: _Txt_Error = "   .    .";  break;
      case 4111: _Txt_Error = "   .    ."; break;
      case 4200: _Txt_Error = "  ";                                   break;
      case 4201: _Txt_Error = "   ";                  break;
      case 4202: _Txt_Error = "  ";                                    break;
      case 4203: _Txt_Error = "  ";                                 break;
      case 4204: _Txt_Error = "  ";                                       break;
      case 4205: _Txt_Error = "  ";                                break;
      case 4206: _Txt_Error = "   ";                            break;
      case 4207: _Txt_Error = "    ";                            break;
      default:   _Txt_Error = " ";
   }
   if(_Num_Error!=0)
   {  Print(_Function+"("+_Num_Error+")"+_Txt_Error);
      if(Alert_ERR) Alert(txt_Comment +":"+_Function+"("+_Num_Error+")"+_Txt_Error);
   }
//----
  return(_Txt_Error);
}
//+------------------------------------------------------------------+
//+-------

